#include <bits/stdc++.h>

using namespace std;

int main()
{
    string t;
    int ll,rl,lr,rr,n,bl1[26],bl2[26],br1[26],br2[26],bl,br,i,p,pp;
    ll=0;
    cin>>t;
    n=t.length()-1;
    rl=n;
    while(t[ll]==t[rl]&&ll<rl)
    {
        ll++;
        rl--;
    }
    if(ll>=rl)
    {
        printf("1");
        return 0;
    }
    lr=ll;
    rr=rl;
    for(i=0;i<26;i++)
    {
        bl1[i]=0;
        bl2[i]=0;
        br1[i]=0;
        br2[i]=0;
    }
    for(i=ll;i<=rl;i++)
    {
        p=(int)t[i]-97;
        bl1[p]++;
        br1[p]++;
    }
    while(true)
    {
        p=(int)t[ll]-97;
        bl1[p]--;
        bl2[p]++;
        if(bl1[p]<bl2[p])
        {
            break;
        }
        ll++;
    }
    while(true)
    {
        p=(int)t[rr]-97;
        br1[p]--;
        br2[p]++;
        if(br1[p]<br2[p])
        {
            break;
        }
        rr--;
    }
    printf("%d",min(rr-lr+1,rl-ll+1));
    return 0;
}